<?php
class ControllerExtensionPaymentFsfPay extends Controller 
{
    private $error = array();
    public function index() 
    {
        $this->load->language('extension/payment/fsfpay');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');
        
        global $classPrefix;
        $OpenCartVersion = floatval(VERSION);
        switch ($OpenCartVersion) {
            case ($OpenCartVersion  >=  2.3 && $OpenCartVersion < 3.0):
                $OpenCartVersion    =   2.3;
                $token              =   'token=' . $this->session->data['token'];
                $urlBase            =   'extension';
                $classPrefix        =   '';
                break;
            case ($OpenCartVersion  >=  3.0 && $OpenCartVersion < 4.0):
                $OpenCartVersion    =   3.0;
                $token              =   'user_token=' . $this->session->data['user_token'];
                $urlBase            =   'marketplace';
                $classPrefix        =   'payment_';
                break;
        }
        
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) 
        {
            $this->model_setting_setting->editSetting($classPrefix.'fsfpay', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link($urlBase.'/extension', $token . '&type=payment', true));
        }
        
        $data['heading_title']      = $this->language->get('heading_title');
        $data['text_edit']          = $this->language->get('text_edit');
        $data['text_enabled']       = $this->language->get('text_enabled');
        $data['text_disabled']      = $this->language->get('text_disabled');
        $data['text_all_zones']     = $this->language->get('text_all_zones');
        $data['text_pending']       = $this->language->get('text_pending');
        $data['text_complete']      = $this->language->get('text_complete');
        $data['entry_merchant_id']  = $this->language->get('entry_merchant_id');
        $data['entry_api_key']      = $this->language->get('entry_api_key');
        $data['entry_secret_key']   = $this->language->get('entry_secret_key');
        $data['entry_order_status'] = $this->language->get('entry_order_status');
        $data['entry_geo_zone']     = $this->language->get('entry_geo_zone');
        $data['entry_status']       = $this->language->get('entry_status');
        $data['entry_sort_order']   = $this->language->get('entry_sort_order');
        $data['entry_fsfpay_id']    = $this->language->get('entry_fsfpay_id');
        $data['button_save']        = $this->language->get('button_save');
        $data['button_cancel']      = $this->language->get('button_cancel');
       
        
        $data['error_warning']      = (isset($this->error['warning']))      ?   $this->error['warning']         : '';
        
        $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', $token, true)
        );

        $data['breadcrumbs'][] = array( 
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link($urlBase.'/extension', $token, true)
        );
        
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link($urlBase.'/extension', $token. '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/fsfpay', $token, true)
        );

        $data['action']     = $this->url->link('extension/payment/fsfpay', $token, true);
        $data['cancel']     = $this->url->link($urlBase.'/extension', $token . '&type=payment', true);
        $data['callback']   = HTTP_CATALOG . 'index.php?route=extension/payment/fsfpay/callback';

        if (isset($this->request->post[$classPrefix.'fsfpay_merchant_id'])) {
            $data[$classPrefix.'fsfpay_merchant_id'] = trim($this->request->post[$classPrefix.'fsfpay_merchant_id']);
        } else {
            $data[$classPrefix.'fsfpay_merchant_id'] = trim($this->config->get($classPrefix.'fsfpay_merchant_id'));
        }

        if (isset($this->request->post[$classPrefix.'fsfpay_api_key'])) {
            $data[$classPrefix.'fsfpay_api_key'] = trim($this->request->post[$classPrefix.'fsfpay_api_key']);
        } else {
            $data[$classPrefix.'fsfpay_api_key'] = trim($this->config->get($classPrefix.'fsfpay_api_key'));
        }
        
        if (isset($this->request->post[$classPrefix.'fsfpay_secret_key'])) {
            $data[$classPrefix.'fsfpay_secret_key'] = trim($this->request->post[$classPrefix.'fsfpay_secret_key']);
        } else {
            $data[$classPrefix.'fsfpay_secret_key'] = trim($this->config->get($classPrefix.'fsfpay_secret_key'));
        }

        if (isset($this->request->post[$classPrefix.'fsfpay_test_mode'])) {
            $data[$classPrefix.'fsfpay_test_mode']     = $this->request->post[$classPrefix.'fsfpay_test_mode'];
        } else {
            $data[$classPrefix.'fsfpay_test_mode']     = $this->config->get($classPrefix.'fsfpay_test_mode');
        }

        if (isset($this->request->post[$classPrefix.'fsfpay_status'])) {
            $data[$classPrefix.'fsfpay_status']     = $this->request->post[$classPrefix.'fsfpay_status'];
        } else {
            $data[$classPrefix.'fsfpay_status']     = $this->config->get($classPrefix.'fsfpay_status');
        }

        if (isset($this->request->post[$classPrefix.'fsfpay_geo_zone_id'])) {
            $data[$classPrefix.'fsfpay_geo_zone_id'] = $this->request->post[$classPrefix.'fsfpay_geo_zone_id'];
        } else {
            $data[$classPrefix.'fsfpay_geo_zone_id'] = $this->config->get($classPrefix.'fsfpay_geo_zone_id');
        }

        if (isset($this->request->post[$classPrefix.'fsfpay_sort_order'])) {
            $data[$classPrefix.'fsfpay_sort_order'] = trim($this->request->post[$classPrefix.'fsfpay_sort_order']);
        } else {
            $data[$classPrefix.'fsfpay_sort_order'] = trim($this->config->get($classPrefix.'fsfpay_sort_order'));
        }
        
        
        $this->load->model('localisation/geo_zone');
        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
        
        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        

        $data['header']         = $this->load->controller('common/header');
        $data['column_left']    = $this->load->controller('common/column_left');
        $data['footer']         = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/fsfpay', $data));
    }
    
    
    
    protected function validate() {
        global $classPrefix;
        
        if (!$this->user->hasPermission('modify', 'extension/payment/fsfpay'))  $this->error['warning'] = $this->language->get('error_permission');
        if (!$this->request->post[$classPrefix.'fsfpay_merchant_id'])           $this->error['receiver_id'] = $this->language->get('error_receiver_id');
        if (!$this->request->post[$classPrefix.'fsfpay_api_key'])          $this->error['receiver_key'] = $this->language->get('error_receiver_key');
      

        return !$this->error;
    }
}