<?php
class ControllerExtensionPaymentFsfPay extends Controller
{
    public function index()
    {

        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['button_back']    = $this->language->get('button_back');
        $data['description']    = $this->config->get('config_name');
        $data['logo']           = $this->config->get('config_url') . 'image/' . $this->config->get('config_logo');
        $data['platform']       = 'opencart';
        $this->load->model('checkout/order');
        $order_info             = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $data['email']          = $order_info['email'];
        $data['customer_id']    = $order_info['customer_id'];
        $data['firstname']      = $order_info['firstname'];
        $data['lastname']       = $order_info['lastname'];
        $data['transaction_id'] = $order_info['order_id'];
        $data['language']       = $this->session->data['language'];

        $data['address'] = ($order_info['payment_address_2']) ? $order_info['payment_address_1'] . ", " . $order_info['payment_address_2'] : $data['address'] = $order_info['payment_address_1'];

        $data['address1']       = $order_info['payment_address_1'];
        $data['address2']       = $order_info['payment_address_2'];
        $data['phone_number']   = $order_info['telephone'];
        $data['postal_code']    = $order_info['payment_postcode'];
        $data['city']           = $order_info['payment_city'];
        $data['state']          = $order_info['payment_zone'];
        $data['country']        = $order_info['payment_iso_code_3'];
        $data['amount']         = ($this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false));
        $data['currency']       = $order_info['currency_code'];

        return $this->load->view('extension/payment/fsfpay', $data);
    }


    public function confirm()
    {
        $this->load->language('extension/payment/fsfpay');
        $OpenCartVersion = floatval(VERSION);
        switch ($OpenCartVersion) {
            case ($OpenCartVersion  >=  2.3 && $OpenCartVersion < 3.0):
                $OpenCartVersion    =   2.3;
                $classPrefix        =   '';
                break;
            case ($OpenCartVersion  >=  3.0 && $OpenCartVersion < 4.0):
                $OpenCartVersion    =   3.0;
                $classPrefix        =   'payment_';
                break;
        }
        if (isset($this->session->data['payment_method']) && $this->session->data['payment_method']['code'] == 'fsfpay') {
            $this->load->model('extension/payment/fsfpay');
            $this->load->model('checkout/order');
            $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
            $paymentAmount = ($this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false));
            $paymentAmount = number_format(floatval($paymentAmount), 2, '.', '');
            $orderId = $order_info['order_id'];
            $ch = curl_init();
            $apiKey = $this->config->get($classPrefix . 'fsfpay_api_key');
            $apiUsername = $this->config->get($classPrefix . 'fsfpay_merchant_id');
            $secretKey = $this->config->get($classPrefix . 'fsfpay_secret_key');
            if (isset($_GET['coin'])) {
                $order = [
                    'id' => $orderId,
                    'customer_email' => $order_info['email'],
                    'amount' => $paymentAmount,
                    'currency' => strtoupper($order_info['currency_code'])
                ];
                $data = [
                    'apiKey' => $apiKey,
                    'apiUsername' => $apiUsername,
                    'orderId' => $order['id'],
                    'email' => $order['customer_email'],
                    'amount' => $order['amount'],
                    'currency' => $order['currency'],
                    'cryptocurrency' => $_GET['coin'],
                    'testmode' => $this->config->get($classPrefix . 'fsfpay_test_mode') == 1 ? 1 : 0,
                    'callbackUrl' => $this->url->link('extension/payment/fsfpay/callback'),
                    'successRedirectUrl' => $this->url->link('checkout/success'),
                    'language' => $this->language->get('code')
                ];
                $data['requestHash'] = hash('sha256', $apiKey . $apiUsername . $secretKey);
                curl_setopt_array($ch, [
                    CURLOPT_URL => 'https://panel.fsfpay.com/api/payment',
                    CURLOPT_HTTPHEADER => [
                        'Content-Type: application/x-www-form-urlencoded'
                    ],
                    CURLOPT_POST => true,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_POSTFIELDS => http_build_query($data)
                ]);
                $response = curl_exec($ch);
                $response = json_decode($response, true);
                if ($response['success']) {
                    $payData = '<script src="' . $response['scriptUrl'] . '"></script>';
                } else {
                    $payData =  'Payment Error: ' . $response['message'];
                }
            }
?>
            <!doctype html>
            <html lang="<?php echo $this->language->get('code') ?>">

            <head>
                <meta charset="utf-8">
                <meta name="viewport" content="width=device-width, initial-scale=1">
                <title>FsfPay</title>
                <link href="https://fonts.googleapis.com/css2?family=Montserrat&display=swap" rel="stylesheet">
                <style>*{box-sizing:border-box;font-family:Montserrat,sans-serif}body{background-color:#f0f0f0;margin:0;min-height:100vh;display:flex;align-items:center;justify-content:center}.card{padding:1rem;border-radius:.5rem;background-color:#fff;width:100%;margin:50px 20px;max-width:1000px;box-shadow:0 0 20px 0 #ececec}</style>
                <?php if (!isset($payData)) {
                ?>
                    <style>.select-coin{border-radius:3px;box-shadow:0 2px 4px 0 rgba(219,215,215,0);border:solid 2px transparent;background:#fff;width:100%;padding:10px;transition:.3s ease-in-out all;margin-top:.5rem;display:flex;align-items:center;justify-content:center}.select-coin div{flex:1}.coin-list{display:flex;margin-top:.5rem;flex-wrap:wrap;gap:.5rem}.select-coin h4{font-size:16px;margin:0!important;letter-spacing:-.24px;color:#1f2949}.select-coin h4:last-of-type{color:#3d3d3d;font-weight:400!important}.coin-label{cursor:pointer;flex:calc(33% - .5rem);max-width:33%}.coin-label input{display:none}.coin-label input:checked~.select-coin{box-shadow:0 2px 4px 0 rgba(219,215,215,.5);border:solid 2px #3057d5}.select-coin img{width:30px!important;height:30px!important}.coin-label input:not(:checked)~.select-coin{border:solid 2px #f5f5f5}.coin-label:hover input:not(:checked)~.select-coin{background:#f9f9f9!important}.coin-button{font-size:1rem!important;margin-top:1.5rem!important;border:solid 2px #3057d5!important;background:#3057d5!important;box-shadow:0 2px 4px 0 rgba(219,215,215,.5)!important;border-radius:.5rem!important;outline:0!important;padding:.5rem 1rem!important;color:#fff!important;cursor:pointer!important}@media (max-width:992px){.coin-label{flex:100%;max-width:100%}}</style>
                <?php
                }
                ?>
            </head>

            <body>
                <div class="card">
                    <?php if (isset($payData)) {
                        echo $payData;
                        echo '<div><a style="display:inline-block!important;color:#ffffff!important;text-decoration:none!important;margin-top:1rem!important;border:solid 2px #3057d5!important;background:#3057d5!important;box-shadow:0 2px 4px 0 rgba(219,215,215,.5)!important;border-radius:.5rem!important;outline:0!important;padding:.5rem 1rem!important" href="index.php?route=extension/payment/fsfpay/confirm" class="coin-button">'.$this->language->get('pay_other').'</a></div>';        
                    } else {
                        $data = [
                            'apiKey' => $apiKey,
                            'apiUsername' => $apiUsername
                        ];
                        $data['requestHash'] = hash('sha256', $apiKey . $apiUsername . $secretKey);
                        curl_setopt_array($ch, [
                            CURLOPT_URL => 'https://panel.fsfpay.com/api/cryptocurrencies',
                            CURLOPT_HTTPHEADER => [
                                'Content-Type: application/x-www-form-urlencoded'
                            ],
                            CURLOPT_POST => true,
                            CURLOPT_RETURNTRANSFER => true,
                            CURLOPT_POSTFIELDS => http_build_query($data)
                        ]);
                        $response = curl_exec($ch);
                        $response = json_decode($response, true);
                        if ($response['success']) {
                    ?>
                            <div><?php echo $this->language->get('select_coin') ?></div>
                            <form action="" method="get">
                                <?php foreach ($_GET as $key => $value) : ?>
                                    <input type="hidden" name="<?php echo htmlspecialchars($key) ?>" value="<?php echo htmlspecialchars($value) ?>">
                                <?php endforeach ?>
                                <div class="coin-list">
                                    <?php foreach ($response['cryptocurrencies'] as $coin => $name) : ?>
                                        <label for="selected-item-<?php echo htmlspecialchars($coin) ?>" class="coin-label">
                                            <input<?php echo $coin == 'BTC' ? ' checked' : '' ?> type="radio" name="coin" value="<?php echo htmlspecialchars($coin) ?>" id="selected-item-<?php echo htmlspecialchars($coin) ?>">
                                                <div class="select-coin">
                                                    <div>
                                                        <h4><?php echo htmlspecialchars($name) ?></h4>
                                                        <h4><?php echo htmlspecialchars($coin) ?></h4>
                                                    </div>
                                                    <img src="https://panel.fsfpay.com/assets/img/coins/<?php echo htmlspecialchars($coin) ?>.png" alt="<?php echo htmlspecialchars($name) ?>" height="30">
                                                </div>
                                        </label>
                                    <?php endforeach ?>
                                </div>
                                <button type="submit" class="coin-button"><?php echo $this->language->get('submit') ?></button>
                            </form>
                    <?php
                        } else {
                            echo 'Payment Error: ' . $response['message'];
                        }
                    }
                    ?>
                </div>
            </body>

            </html>
<?php
        }
    }


    public function callback()
    {
        $OpenCartVersion = floatval(VERSION);
        switch ($OpenCartVersion) {
            case ($OpenCartVersion  >=  2.3 && $OpenCartVersion < 3.0):
                $OpenCartVersion    =   2.3;
                $classPrefix        =   '';
                break;
            case ($OpenCartVersion  >=  3.0 && $OpenCartVersion < 4.0):
                $OpenCartVersion    =   3.0;
                $classPrefix        =   'payment_';
                break;
        }
        $apiKey = $this->config->get($classPrefix . 'fsfpay_api_key');
        $apiUsername = $this->config->get($classPrefix . 'fsfpay_merchant_id');
        $secretKey = $this->config->get($classPrefix . 'fsfpay_secret_key');
        if(isset($_POST['requestHash']) && $_POST['paymentStatus'] && $_POST['paymentStatus'] == 'successful') {
            if(hash('sha256', $apiKey . $apiUsername . $secretKey) === $_POST['requestHash']) {
                $paymentId = $_POST['paymentId'];
                $orderId = $_POST['orderId'];
                $orderStatus=5;
                $this->load->model('checkout/order');
                $order = $this->model_checkout_order->getOrder($orderId);
                if ($order["order_status_id"] != $orderStatus) {               
                    $this->model_checkout_order->addOrderHistory($orderId, $orderStatus);
                }
                $amount = $_POST['amount'];
                $email = $_POST['email'];
                $currency = $_POST['currency'];
                $cryptocurrencyAmount = $_POST['cryptocurrencyAmount'];
                $testmode = $_POST['testmode'];
                die('OK');
            }
        }
        die;
        
    }
}
